﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace wherever
{
    class Program
    {
        static void Main(string[] args)
        {
            // list the drives on the system
            DriveInfo[] drives = DriveInfo.GetDrives();

            // we are going in reverse order, so as to prefer usb/removable drives over say c:
            //  -- not sure if the numberic ordering and the alphabetic ordering are always lined up, but meh.  Close enough.  -Eli
            for (int i = drives.Count() - 1; i >= 0; i--)
            {
                string path = drives[i].Name + args[0];
                if (File.Exists(path )){

                    // we found our file, lets kick it off and quit
                    var startInfo = new ProcessStartInfo();
                    startInfo.WorkingDirectory = Path.GetDirectoryName(path);
                    startInfo.FileName = path;
                    System.Diagnostics.Process.Start(startInfo);

                    Environment.Exit(0);
                }       
            }
            // error message
            Console.WriteLine("\nERROR: Could not find ?:\\" + args[0] + ", aborting.");
            Console.WriteLine("");

            // branding!  yeah!
            Console.WriteLine("-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-");
            Console.WriteLine("Documentation:\n");
            Console.WriteLine("Wherever is a command line tool for starting a process that has an unreliable\ndrive letter.  For instance, if you really want a shortcut on your desktop\nthat points at a USB drive.\n");
            Console.WriteLine("For instance, \"wherever example.exe\" will look in all your drive letters, in\nreverse order, for \"G:\\example.exe\", \"F:\\example.exe\"... and so forth until a\nmatching file is found and executed.\n");
            Console.WriteLine("wherever.exe version 0.1 by Eli Fulkerson, Jul-29-2015");
            Console.WriteLine("http://www.elifulkerson.com for updates");
            Console.WriteLine("-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-");
        }
    }
}
